summaryrefslogtreecommitdiffstats
path: root/target/linux/kirkwood
diff options
context:
space:
mode:
authorLuka Perkov <luka@openwrt.org>2015-11-10 00:16:42 +0000
committerLuka Perkov <luka@openwrt.org>2015-11-10 00:16:42 +0000
commitb0e7ca4f8f6c85b0382ec54f85cc208f89ec3947 (patch)
treed5e1cd7bd74a25cf18e1d06493dde2330daf2ec8 /target/linux/kirkwood
parentea8ac0999cb78399acf3af6d8eb6fe5b92d06f53 (diff)
downloadmaster-31e0f0ae-b0e7ca4f8f6c85b0382ec54f85cc208f89ec3947.tar.gz
master-31e0f0ae-b0e7ca4f8f6c85b0382ec54f85cc208f89ec3947.tar.bz2
master-31e0f0ae-b0e7ca4f8f6c85b0382ec54f85cc208f89ec3947.zip
kirkwood: support sysupgrade on Linksys EA[34]500
This automatically writes to the alternate firmware partition (on Linksys's dual firmware layout) using code borrowed from the WRT1900AC port. Signed-off-by: Claudio Leite <leitec@staticky.com> SVN-Revision: 47434
Diffstat (limited to 'target/linux/kirkwood')
-rw-r--r--target/linux/kirkwood/base-files/lib/upgrade/linksys.sh79
-rw-r--r--target/linux/kirkwood/base-files/lib/upgrade/platform.sh32
2 files changed, 111 insertions, 0 deletions
diff --git a/target/linux/kirkwood/base-files/lib/upgrade/linksys.sh b/target/linux/kirkwood/base-files/lib/upgrade/linksys.sh
new file mode 100644
index 0000000000..13a8f1cb55
--- /dev/null
+++ b/target/linux/kirkwood/base-files/lib/upgrade/linksys.sh
@@ -0,0 +1,79 @@
+#
+# Copyright (C) 2014 OpenWrt.org
+#
+
+linksys_get_target_firmware() {
+ cur_boot_part=`/usr/sbin/fw_printenv -n boot_part`
+ target_firmware=""
+ if [ "$cur_boot_part" = "1" ]
+ then
+ # current primary boot - update alt boot
+ target_firmware="kernel2"
+ fw_setenv boot_part 2
+ fw_setenv bootcmd "run altnandboot"
+ elif [ "$cur_boot_part" = "2" ]
+ then
+ # current alt boot - update primary boot
+ target_firmware="kernel1"
+ fw_setenv boot_part 1
+ fw_setenv bootcmd "run nandboot"
+ fi
+
+ echo "$target_firmware"
+}
+
+linksys_get_root_magic() {
+ (get_image "$@" | dd skip=786432 bs=4 count=1 | hexdump -v -n 4 -e '1/1 "%02x"') 2>/dev/null
+}
+
+platform_do_upgrade_linksys() {
+ local magic_long="$(get_magic_long "$1")"
+
+ mkdir -p /var/lock
+ local part_label="$(linksys_get_target_firmware)"
+ touch /var/lock/fw_printenv.lock
+
+ if [ ! -n "$part_label" ]
+ then
+ echo "cannot find target partition"
+ exit 1
+ fi
+
+ local target_mtd=$(find_mtd_part $part_label)
+
+ [ "$magic_long" = "73797375" ] && {
+ CI_KERNPART="$part_label"
+ if [ "$part_label" = "kernel1" ]
+ then
+ CI_UBIPART="rootfs1"
+ else
+ CI_UBIPART="rootfs2"
+ fi
+
+ nand_upgrade_tar "$1"
+ }
+ [ "$magic_long" = "27051956" ] && {
+ # check firmwares' rootfs types
+ local target_mtd=$(find_mtd_part $part_label)
+ local oldroot="$(linksys_get_root_magic $target_mtd)"
+ local newroot="$(linksys_get_root_magic "$1")"
+
+ if [ "$newroot" = "55424923" -a "$oldroot" = "55424923" ]
+ # we're upgrading from a firmware with UBI to one with UBI
+ then
+ # erase everything to be safe
+ mtd erase $part_label
+ get_image "$1" | mtd -n write - $part_label
+ else
+ get_image "$1" | mtd write - $part_label
+ fi
+ }
+}
+
+linksys_preupgrade() {
+ export RAMFS_COPY_BIN="${RAMFS_COPY_BIN} /usr/sbin/fw_printenv /usr/sbin/fw_setenv"
+ export RAMFS_COPY_BIN="${RAMFS_COPY_BIN} /bin/mkdir /bin/touch"
+ export RAMFS_COPY_DATA="${RAMFS_COPY_DATA} /etc/fw_env.config /var/lock/fw_printenv.lock"
+}
+
+append sysupgrade_pre_upgrade linksys_preupgrade
diff --git a/target/linux/kirkwood/base-files/lib/upgrade/platform.sh b/target/linux/kirkwood/base-files/lib/upgrade/platform.sh
new file mode 100644
index 0000000000..c33229a41b
--- /dev/null
+++ b/target/linux/kirkwood/base-files/lib/upgrade/platform.sh
@@ -0,0 +1,32 @@
+. /lib/kirkwood.sh
+
+platform_check_image() {
+ [ "$#" -gt 1 ] && return 1
+ local board="$(kirkwood_board_name)"
+ local magic="$(get_magic_long "$1")"
+
+ case "$board" in
+ "linksys-audi"|\
+ "linksys-viper")
+ [ "$magic" != "27051956" -a "$magic" != "73797375" ] && {
+ echo "Invalid image type."
+ return 1
+ }
+ return 0
+ ;;
+ esac
+
+ echo "Sysupgrade is not yet supported on $board."
+ return 1
+}
+
+platform_do_upgrade() {
+ local board="$(kirkwood_board_name)"
+
+ case "$board" in
+ "linksys-audi"|\
+ "linksys-viper")
+ platform_do_upgrade_linksys "$ARGV"
+ ;;
+ esac
+}